#include "PageDragon2.h"
#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>

#include <Adafruit_NeoPixel.h>
#include <Servo.h>

IPAddress local_IP(192,168,4,2);
IPAddress gateway(192,168,4,1);
IPAddress subnet(255,255,252,0);
int WiFi_OK;
int WiFi_Mode = 1;
ESP8266WebServer server(80);

Adafruit_NeoPixel pixels_Dragon = Adafruit_NeoPixel(2, 14, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel pixels_Ile = Adafruit_NeoPixel(11, 15, NEO_GRB + NEO_KHZ800);
Servo Head;
Servo Body;
Servo Tail;
long math_random_int(int a,int b) {
  if (a > b) {
    // Swap a and b to ensure a is smaller.
    int c = a;
    a = b;
    b = c;
  }
  return random(a,b);
}

int nbArgs;
int EtatDragon;
long HeureStartDragon;
int DEbutYeuxROuge;
int FinYeuxROuge;
long HeureChangeBouton;
int EtatLED;
long HeureStartLED;
int EtatSErvo;
int EtatBouton;
int OldBouton;
int NewBouton;
unsigned long LastMessage;
unsigned long NextMoveServo;
String UrlInconnue;
int i;
int AngleTail;
int AngleHead;
int AngleBody;

// Décrire cette fonction
void ENvoiPage() {
  nbArgs = server.args();
  Serial.print("Reception requete, NbArgs=");
   Serial.print(nbArgs);
  if (nbArgs == 2 && server.argName(0) == "dragon") {
    if (server.arg(0) == "On") {
      EtatDragon = 1;
      HeureStartDragon = millis();
      DEbutYeuxROuge = millis() + 5000;
      FinYeuxROuge = millis() + 10000;

    } else {
      EtatDragon = 0;

    }
    HeureChangeBouton = millis();

  }
  if (nbArgs == 2 && server.argName(1) == "LED") {
    if (server.arg(1) == "On") {
      EtatLED = 1;
      HeureStartLED = millis();

    } else {
      EtatLED = 0;

    }
    HeureChangeBouton = millis();

  }
  server.send(200, "text/html", PageDragon);
  Serial.print("Sortie requete dragon, dragon:");
   Serial.print(EtatDragon);
  Serial.print("  LED:");
   Serial.println(EtatLED);
}


// Décrire cette fonction
void FonctionURLNotFound() {
  UrlInconnue = server.uri();
  Serial.print("URL inconnue: ");
   Serial.println(UrlInconnue);
}



void setup() {
  Serial.begin(115200);
  WiFi_OK = WiFi.softAPConfig(local_IP, gateway, subnet);
WiFi_OK &= WiFi.softAP("HurlyWind");

  pinMode(14, OUTPUT);
  pixels_Dragon.begin();
  pinMode(15, OUTPUT);
  pixels_Ile.begin();
  Head.attach(4);
  Body.attach(5);
  Tail.attach(2);
    server.on("/", ENvoiPage);
  server.on("/Dragon.html", ENvoiPage);
  server.onNotFound(FonctionURLNotFound);
  server.begin();Serial.println("ServeurWeb Lancé");
  EtatSErvo = 0;
  EtatBouton = 0;
  EtatDragon = 0;
  EtatLED = 0;
  OldBouton = 1;
  NewBouton = 1;
  HeureStartDragon = (unsigned long)(0);
  HeureStartLED = (unsigned long)(0);
  LastMessage = (unsigned long)(0);
  HeureChangeBouton = (unsigned long)(0);
  DEbutYeuxROuge = (unsigned long)(0);
  FinYeuxROuge = (unsigned long)(0);
  NextMoveServo = (unsigned long)(0);
  delay(2000);
  Head.write(180);
  Body.write(90);
  Tail.write(0);

  pinMode(0, INPUT);
}

void loop() {
    server.handleClient();
    if (LastMessage < HeureChangeBouton) {
      Serial.print("Timems:");
       Serial.print(millis());
      Serial.print("  Variable LED:");
       Serial.print(EtatLED);
      Serial.print("Variable Dragon:");
       Serial.println(EtatDragon);
      LastMessage = millis();

    }

  NewBouton = digitalRead(0);
  if (NewBouton == 0 && OldBouton == 1) {
    EtatBouton = EtatBouton + 1;
    if (EtatBouton >= 3) {
      EtatBouton = 0;
      EtatLED = 0;
      EtatDragon = 0;

    }
    if (EtatBouton == 1) {
      EtatLED = 1;
      EtatDragon = 0;

    }
    if (EtatBouton == 2) {
      EtatLED = 1;
      EtatDragon = 1;
      HeureStartDragon = millis();
      DEbutYeuxROuge = millis() + 5000;
      FinYeuxROuge = millis() + 10000;

    }

  }
  OldBouton = NewBouton;
  pixels_Ile.setPixelColor(9, pixels_Ile.Color(math_random_int(30, 70),math_random_int(2, 8),0));
  pixels_Ile.show();
  if (EtatLED == 1) {
    for (i = 0; i <= 9; i=i+1) {
      pixels_Ile.setPixelColor(i, pixels_Ile.Color(math_random_int(200, 255),math_random_int(150, 200),math_random_int(0, 20)));
      pixels_Ile.show();
    }
    pixels_Ile.setPixelColor(10, pixels_Ile.Color(155,155,155));
    pixels_Ile.show();

  } else {
    for (i = 0; i <= 8; i=i+1) {
      pixels_Ile.setPixelColor(i, pixels_Ile.Color(0,0,0));
      pixels_Ile.show();
    }
    pixels_Ile.setPixelColor(10, pixels_Ile.Color(0,0,0));
    pixels_Ile.show();

  }
  if (EtatDragon == 1 && millis() >= NextMoveServo) {
    NextMoveServo = millis() + 10;
    EtatSErvo = EtatSErvo + 1;
    if (EtatSErvo >= 360) {
      EtatSErvo = 0;

    }
    if (EtatSErvo > 180) {
      AngleTail = 360 - EtatSErvo;

    } else {
      AngleTail = EtatSErvo;

    }
    AngleHead = EtatSErvo + 90;
    if (AngleHead > 360) {
      AngleHead = AngleHead - 360;

    }
    if (AngleHead > 180) {
      AngleHead = 360 - AngleHead;

    }
    AngleBody = EtatSErvo + 180;
    if (AngleBody > 360) {
      AngleBody = AngleBody - 360;

    }
    if (AngleBody > 180) {
      AngleBody = 360 - AngleBody;

    }
    Head.write(AngleHead);
    Tail.write(AngleTail);
    Body.write(AngleBody);

  }
  if (millis() >= DEbutYeuxROuge && millis() <= FinYeuxROuge) {
    for (i = 0; i <= 1; i=i+1) {
      pixels_Dragon.setPixelColor(i, pixels_Dragon.Color(math_random_int(200, 250),math_random_int(0, 40),math_random_int(0, 50)));
      pixels_Dragon.show();
    }

  } else {
    for (i = 0; i <= 1; i=i+1) {
      pixels_Dragon.setPixelColor(i, pixels_Dragon.Color(math_random_int(0, 150),math_random_int(100, 190),math_random_int(220, 250)));
      pixels_Dragon.show();
    }

  }

}
